
struct hl_hdr_type {
	char *name;
	u_int32_t type;
};

struct hl_hdr_type hl_h_types[] = {
	{ "HTLC_HDR_NEWSFILE_GET", 0x00000065 },
	{ "HTLC_HDR_NEWSFILE_POST", 0x00000067 },
	{ "HTLC_HDR_CHAT", 0x00000069 },
	{ "HTLC_HDR_LOGIN", 0x0000006b },
	{ "HTLC_HDR_MSG", 0x0000006c },
	{ "HTLC_HDR_USER_KICK", 0x0000006e },
	{ "HTLC_HDR_CHAT_CREATE", 0x00000070 },
	{ "HTLC_HDR_CHAT_INVITE", 0x00000071 },
	{ "HTLC_HDR_CHAT_DECLINE", 0x00000072 },
	{ "HTLC_HDR_CHAT_JOIN", 0x00000073 },
	{ "HTLC_HDR_CHAT_PART", 0x00000074 },
	{ "HTLC_HDR_CHAT_SUBJECT", 0x00000078 },
	{ "HTLC_HDR_AGREEMENTAGREE", 0x00000079 },
	{ "HTLC_HDR_FILE_LIST", 0x000000c8 },
	{ "HTLC_HDR_FILE_GET", 0x000000ca },
	{ "HTLC_HDR_FILE_PUT", 0x000000cb },
	{ "HTLC_HDR_FILE_DELETE", 0x000000cc },
	{ "HTLC_HDR_FILE_MKDIR", 0x000000cd },
	{ "HTLC_HDR_FILE_GETINFO", 0x000000ce },
	{ "HTLC_HDR_FILE_SETINFO", 0x000000cf },
	{ "HTLC_HDR_FILE_MOVE", 0x000000d0 },
	{ "HTLC_HDR_FILE_SYMLINK", 0x000000d1 },
	{ "HTLC_HDR_FILE_GETFOLDER", 0x000000d2 },
	{ "HTLC_HDR_BANNER_GET", 0x000000d4 },
	{ "HTLC_HDR_FILE_PUTFOLDER", 0x000000d5 },
	{ "HTLC_HDR_KILLDOWNLOAD", 0x000000d6 },
	{ "HTLC_HDR_USER_GETLIST", 0x0000012c },
	{ "HTLC_HDR_USER_GETINFO", 0x0000012f },
	{ "HTLC_HDR_USER_CHANGE", 0x00000130 },
	{ "HTLC_HDR_ACCOUNT_CREATE", 0x0000015e },
	{ "HTLC_HDR_ACCOUNT_DELETE", 0x0000015f },
	{ "HTLC_HDR_ACCOUNT_READ", 0x00000160 },
	{ "HTLC_HDR_ACCOUNT_MODIFY", 0x00000161 },
	{ "HTLC_HDR_MSG_BROADCAST", 0x00000163 },
	{ "HTLC_HDR_NEWS_LISTDIR", 0x00000172 },
	{ "HTLC_HDR_NEWS_LISTCATEGORY", 0x00000173 },
	{ "HTLC_HDR_NEWS_DELETE", 0x0000017c },
	{ "HTLC_HDR_NEWS_MKDIR", 0x0000017d },
	{ "HTLC_HDR_NEWS_MKCATEGORY", 0x0000017e },
	{ "HTLC_HDR_NEWS_GETTHREAD", 0x00000190 },
	{ "HTLC_HDR_NEWS_POSTTHREAD", 0x0000019a },
	{ "HTLC_HDR_NEWS_DELETETHREAD", 0x0000019b },
	{ "HTLC_HDR_PING", 0x000001f4 },
	{ "HTLS_HDR_NEWSFILE_POST", 0x00000066 },
	{ "HTLS_HDR_MSG", 0x00000068 },
	{ "HTLS_HDR_CHAT", 0x0000006a },
	{ "HTLS_HDR_AGREEMENT", 0x0000006d },
	{ "HTLS_HDR_POLITEQUIT", 0x0000006f },
	{ "HTLS_HDR_CHAT_INVITE", 0x00000071 },
	{ "HTLS_HDR_CHAT_USER_CHANGE", 0x00000075 },
	{ "HTLS_HDR_CHAT_USER_PART", 0x00000076 },
	{ "HTLS_HDR_CHAT_SUBJECT", 0x00000077 },
	{ "HTLS_HDR_BANNER", 0x0000007a },
	{ "HTLS_HDR_QUEUE_UPDATE", 0x000000d3 },
	{ "HTLS_HDR_USER_CHANGE", 0x0000012d },
	{ "HTLS_HDR_USER_PART", 0x0000012e },
	{ "HTLS_HDR_USER_SELFINFO", 0x00000162 },
	{ "HTLS_HDR_MSG_BROADCAST", 0x00000163 },
	{ "HTLS_HDR_TASK", 0x00010000 },
	{ "HTLS_HDR_PING", 0x000001f4 },
	{ "HTLS_HDR_ICON_CHANGE", 0x00000748 },
	{ "HTLC_HDR_FILE_HASH", 0x00000ee0 },
	{ "HTLC_HDR_ICON_GETLIST", 0x00000745 },
	{ "HTLC_HDR_ICON_SET", 0x00000746 },
	{ "HTLC_HDR_ICON_GET", 0x00000747 },
	{ "HTLS_HDR_ICON_CHANGE", 0x00000748 },
};

struct hl_data_hdr_type {
	char *name;
	u_int16_t type;
};

struct hl_data_hdr_type hl_dh_types[] = {
	{ "HTLC_DATA_CHAT", 0x0065 },
	{ "HTLC_DATA_MSG", 0x0065 },
	{ "HTLC_DATA_NEWSFILE_POST", 0x0065 },
	{ "HTLC_DATA_NAME", 0x0066 },
	{ "HTLC_DATA_UID", 0x0067 },
	{ "HTLC_DATA_ICON", 0x0068 },
	{ "HTLC_DATA_LOGIN", 0x0069 },
	{ "HTLC_DATA_PASSWORD", 0x006a },
	{ "HTLC_DATA_HTXF_SIZE", 0x006c },
	{ "HTLC_DATA_STYLE", 0x006d },
	{ "HTLC_DATA_ACCESS", 0x006e },
	{ "HTLC_DATA_BAN", 0x0071 },
	{ "HTLC_DATA_CHAT_ID", 0x0072 },
	{ "HTLC_DATA_CHAT_SUBJECT", 0x0073 },
	{ "HTLC_DATA_CLIENTVERSION", 0x00a0 },
	{ "HTLC_DATA_FILE_NAME", 0x00c9 },
	{ "HTLC_DATA_DIR", 0x00ca },
	{ "HTLC_DATA_RFLT", 0x00cb },
	{ "HTLC_DATA_FILE_PREVIEW", 0x00cc },
	{ "HTLC_DATA_FILE_COMMENT", 0x00d2 },
	{ "HTLC_DATA_FILE_RENAME", 0x00d3 },
	{ "HTLC_DATA_DIR_RENAME", 0x00d4 },
	{ "HTLC_DATA_FILE_NFILES", 0x00dc },
	{ "HTLC_DATA_NEWS_DIRLIST", 0x0140 },
	{ "HTLC_DATA_NEWS_CATLIST", 0x0141 },
	{ "HTLC_DATA_NEWS_CATNAME", 0x0142 },
	{ "HTLC_DATA_NEWS_DIR", 0x0145 },
	{ "HTLC_DATA_NEWS_THREADID", 0x0146 },
	{ "HTLC_DATA_NEWS_MIMETYPE", 0x0147 },
	{ "HTLC_DATA_NEWS_SUBJECT", 0x0148 },
	{ "HTLC_DATA_NEWS_POSTER", 0x0149 },
	{ "HTLC_DATA_NEWS_DATE", 0x014a },
	{ "HTLC_DATA_NEWS_PREVTHREADID", 0x014b },
	{ "HTLC_DATA_NEWS_NEXTTHREADID", 0x014c },
	{ "HTLC_DATA_NEWS_POST", 0x014d },
	{ "HTLC_DATA_NEWS_PARENTTHREADID", 0x014f },
	{ "HTLC_DATA_NEWS_NEXTSUBTHREADID", 0x0150 },
	{ "HTLC_DATA_NEWS_DELETEREPLIES", 0x0151 },
	{ "HTLS_DATA_TASKERROR", 0x0064 },
	{ "HTLS_DATA_TEXT", 0x0065 },
	{ "HTLS_DATA_NEWS", 0x0065 },
	{ "HTLS_DATA_AGREEMENT", 0x0065 },
	{ "HTLS_DATA_USER_INFO", 0x0065 },
	{ "HTLS_DATA_CHAT", 0x0065 },
	{ "HTLS_DATA_MSG", 0x0065 },
	{ "HTLS_DATA_NAME", 0x0066 },
	{ "HTLS_DATA_UID", 0x0067 },
	{ "HTLS_DATA_ICON", 0x0068 },
	{ "HTLS_DATA_LOGIN", 0x0069 },
	{ "HTLS_DATA_PASSWORD", 0x006a },
	{ "HTLS_DATA_HTXF_REF", 0x006b },
	{ "HTLS_DATA_HTXF_SIZE", 0x006c },
	{ "HTLS_DATA_STYLE", 0x006d },
	{ "HTLS_DATA_ACCESS", 0x006e },
	{ "HTLS_DATA_COLOR", 0x0070 },
	{ "HTLS_DATA_CHAT_ID", 0x0072 },
	{ "HTLS_DATA_CHAT_SUBJECT", 0x0073 },
	{ "HTLS_DATA_QUEUE_POSITION", 0x0074 },
	{ "HTLS_DATA_BANNER", 0x0097 },
	{ "HTLS_DATA_BANNER_TYPE", 0x0098 },
	{ "HTLS_DATA_BANNER_URL", 0x0099 },
	{ "HTLS_DATA_NOAGREEMENT", 0x009a },
	{ "HTLS_DATA_SERVERVERSION", 0x00a0 },
	{ "HTLS_DATA_BANNERID", 0x00a1 },
	{ "HTLS_DATA_SERVERNAME", 0x00a2 },
	{ "HTLS_DATA_FILE_LIST", 0x00c8 },
	{ "HTLS_DATA_FILE_NAME", 0x00c9 },
	{ "HTLS_DATA_RFLT", 0x00cb },
	{ "HTLS_DATA_FILE_TYPE", 0x00cd },
	{ "HTLS_DATA_FILE_CREATOR", 0x00ce },
	{ "HTLS_DATA_FILE_SIZE", 0x00cf },
	{ "HTLS_DATA_FILE_DATE_CREATE", 0x00d0 },
	{ "HTLS_DATA_FILE_DATE_MODIFY", 0x00d1 },
	{ "HTLS_DATA_FILE_COMMENT", 0x00d2 },
	{ "HTLS_DATA_FILE_ICON", 0x00d5 },
	{ "HTLS_DATA_FILE_NFILES", 0x00dc },
	{ "HTLS_DATA_USER_LIST", 0x012c },
	{ "HTLS_DATA_NEWS_DIRLIST", 0x0140 },
	{ "HTLS_DATA_NEWS_CATLIST", 0x0141 },
	{ "HTLS_DATA_NEWS_DIRLIST_EXTENDED", 0x0143 },
	{ "HTLS_DATA_NEWS_DIR", 0x0145 },
	{ "HTLS_DATA_NEWS_THREADID", 0x0146 },
	{ "HTLS_DATA_NEWS_MIMETYPE", 0x0147 },
	{ "HTLS_DATA_NEWS_SUBJECT", 0x0148 },
	{ "HTLS_DATA_NEWS_POSTER", 0x0149 },
	{ "HTLS_DATA_NEWS_DATE", 0x014a },
	{ "HTLS_DATA_NEWS_PREVTHREADID", 0x014b },
	{ "HTLS_DATA_NEWS_NEXTTHREADID", 0x014c },
	{ "HTLS_DATA_NEWS_POST", 0x014d },
	{ "HTLS_DATA_NEWS_PARENTTHREADID", 0x014f },
	{ "HTLS_DATA_NEWS_NEXTSUBTHREADID", 0x0150 },
	{ "HTLC_DATA_HASH_MD5", 0x0e80 },
	{ "HTLC_DATA_HASH_HAVAL", 0x0e81 },
	{ "HTLC_DATA_HASH_SHA1", 0x0e82 },
	{ "HTLC_DATA_CHAT_AWAY", 0x0ea1 },
	{ "HTLS_DATA_HASH_MD5", 0x0e80 },
	{ "HTLS_DATA_HASH_HAVAL", 0x0e81 },
	{ "HTLS_DATA_HASH_SHA1", 0x0e82 },
	{ "HTLS_DATA_ICON_CICN", 0x0e90 },
	{ "HTLS_DATA_SID", 0x0e67 },
	{ "HTLS_DATA_SESSIONKEY", 0x0e03 },
	{ "HTLC_DATA_SESSIONKEY", 0x0e03 },
	{ "HTLS_DATA_MAC_ALG", 0x0e04 },
	{ "HTLC_DATA_MAC_ALG", 0x0e04 },
	{ "HTLS_DATA_CIPHER_ALG", 0x0ec1 },
	{ "HTLC_DATA_CIPHER_ALG", 0x0ec2 },
	{ "HTLS_DATA_CIPHER_MODE", 0x0ec3 },
	{ "HTLC_DATA_CIPHER_MODE", 0x0ec4 },
	{ "HTLS_DATA_CIPHER_IVEC", 0x0ec5 },
	{ "HTLC_DATA_CIPHER_IVEC", 0x0ec6 },
	{ "HTLS_DATA_CHECKSUM_ALG", 0x0ec7 },
	{ "HTLC_DATA_CHECKSUM_ALG", 0x0ec8 },
	{ "HTLS_DATA_COMPRESS_ALG", 0x0ec9 },
	{ "HTLC_DATA_COMPRESS_ALG", 0x0eca },
	{ "HTLS_DATA_ICON_GIF", 0x0300 },
	{ "HTLC_DATA_ICON_GIF", 0x0300 },
	{ "HTLS_DATA_ICON_LIST", 0x0301 },
	{ "HTLC_DATA_COLOR", 0x0500 },
};
